/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2021/06/06
 * Description        : Main program body.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for 
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/

/*
 *@Note


*/

#include "debug.h"

/* Global typedef */

/* Global define */

/* Global Variable */
#define buffer_len 256

u8 USART_Rbuffer[buffer_len];          //ջ
volatile u16 USART_RX_STA=0;           //״̬

/*******************************************************************************
* Function Name  : USARTx_CFG
* Description    : Initializes the USART2 & USART3 peripheral.
* Input          : None
* Return         : None
*******************************************************************************/
void USARTx_CFG(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure={0};
  USART_InitTypeDef USART_InitStructure={0};
  NVIC_InitTypeDef  NVIC_InitStructure={0};

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);  //ʹGPIOAʱ
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE); //ʹܴ2ʱ

  USART_DeInit(USART2);
  /* USART2 TX-->A.2   RX-->A.3 */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;              //PA2Ϊ
  GPIO_Init(GPIOA, &GPIO_InitStructure);
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;        //PA3Ϊ
  GPIO_Init(GPIOA, &GPIO_InitStructure);

  USART_InitStructure.USART_BaudRate = 115200;                 //ôڲΪ115200
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;  //ֳΪ8λݸʽ
  USART_InitStructure.USART_StopBits = USART_StopBits_1;       //1ֹͣλ
  USART_InitStructure.USART_Parity = USART_Parity_No;          //żУλ
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;//Ӳ
  USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx; //ͺͽģʽ
  USART_Init(USART2, &USART_InitStructure);                    //ʼ

  NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;      //ռȼΪ1
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;           //ȼΪ1
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;              //IRQͨʹ
  NVIC_Init(&NVIC_InitStructure);                              //жȼʼ

  USART_Cmd(USART2, ENABLE);                                   //ʹܴ
  USART_ITConfig(USART2, USART_IT_RXNE, ENABLE);               //ж
}

void USARTx_SendByte(USART_TypeDef* pUSARTx, uint8_t data)
{
    USART_SendData(pUSARTx, data);
    while(USART_GetFlagStatus(pUSARTx, USART_FLAG_TXE) == RESET);
}

void USARTx_SendStr(USART_TypeDef* pUSARTx, char *str)
{
    uint8_t i = 0;
    do
    {
       USARTx_SendByte(pUSARTx, *(str+i));
       i++;
    }while(*(str+i) != '\0');
    while(USART_GetFlagStatus(pUSARTx, USART_FLAG_TC) == RESET);
}

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    u16 t;
    u16 len;

    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();
    USART_Printf_Init(115200);
    printf("SystemClk:%d\r\n", SystemCoreClock);

    printf("This is printf example\r\n");

    USARTx_CFG();

    while(1)
    {
        if(USART_RX_STA&0x8000)
        {
            len=USART_RX_STA&0x3fff;//õ˴νյݳ
            printf("len=%d\r\n",len);
            for(t=0;t<len;t++)
            {
                USART_SendData(USART2, USART_Rbuffer[t]);//򴮿1
                while(USART_GetFlagStatus(USART2,USART_FLAG_TC)!=SET);//ȴͽ
            }
            USART_RX_STA=0;
        }
    }
}


void USART2_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
/*******************************************************************************
* Function Name  : USART2_IRQHandler
* Description    : This function handles USART2 global interrupt request.
* Input          : None
* Return         : None
*******************************************************************************/
void USART2_IRQHandler(void)
{
    u8 data;
    if(USART_GetITStatus(USART2, USART_IT_RXNE) != RESET) //жϲ
    {
        USART_ClearITPendingBit(USART2,USART_IT_RXNE);    //жϱ־

        data = USART_ReceiveData(USART2); //
        if((USART_RX_STA&0x8000)==0)//δ
        {
            if(USART_RX_STA&0x4000)//յ0x0d
            {
                if(data!=0x0a)USART_RX_STA=0;//մ,¿ʼ
                else USART_RX_STA|=0x8000;  //
            }
            else //ûյ0X0D
            {
                if(data==0x0d)
                    USART_RX_STA|=0x4000;
                else
                {
                    USART_Rbuffer[USART_RX_STA&0X3FFF]=data ;
                    USART_RX_STA++;
                    if(USART_RX_STA>(buffer_len-1))
                        USART_RX_STA=0;//ݴ,¿ʼ
                }
            }
        }
    }
}
